/*
 *  H8 Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

#ifndef _SERIAL_H_
#define _SERIAL_H_

/*
 *	serial.h -- H8 Serial Definitions
 */

/*	Default Values	*/

#define DEF_SCITX_BUFF_SIZE	128				/* default SCI Transmit buffer size */
#define DEF_SCIRX_BUFF_SIZE	128				/* default SCI Recive   buffer size */
#define DEFAULT_LINE_SIZE	(DEF_SCIRX_BUFF_SIZE - 1)	/* default line size (without terminator) */

#if 1
#define DEFAULT_SPEED		38400
#else	/* of #if 1 */
#define DEFAULT_SPEED		9600
#endif	/* of #if 1 */

#define DEFAULT_SMR		0x00	/* Async, 8 bits, No parity, 1 stop bit, no MP, 1/1 */
#define DEFAULT_BRR		(CLOCK_RATE / 32 / DEFAULT_SPEED - 1)

/*	Parameters	*/

#define SCI_LOW_WMARK		(DEF_SCIRX_BUFF_SIZE / 3)
#define SCI_HIGH_WMARK		(SCI_LOW_WMARK * 2)

/*
 *	External Functions
 */

		.global		_SendChar
		.global		_ReciveChar
		.global		_InitSerial

		.global		_InterERI0	/* SCI #0, Error */
		.global		_InterRXI0	/* SCI #0, Recive */
		.global		_InterTXI0	/* SCI #0, Transmit empty */
		.global		_InterTEI0	/* SCI #0, Transmit end */

#if MAX_SERIAL >= 2

		.global		_InterERI1	/* SCI #1, Error */
		.global		_InterRXI1	/* SCI #1, Recive */
		.global		_InterTXI1	/* SCI #1, Transmit empty */
		.global		_InterTEI1	/* SCI #1, Transmit end */

#endif	/* of #if MAX_SERIAL >= 2 */

#if MAX_SERIAL >= 3

		.global		_InterERI2	/* SCI #2, Error */
		.global		_InterRXI2	/* SCI #2, Recive */
		.global		_InterTXI2	/* SCI #2, Transmit empty */
		.global		_InterTEI2	/* SCI #2, Transmit end */

#endif	/* of #if MAX_SERIAL >= 3 */

#endif	/* of #ifndef _SERIAL_H_ */
