/*
 *  H8 Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

#ifndef _MONDEFS_H_
#define _MONDEFS_H_

/*
 *	mondefs.h -- H8 Monitor Core Definitions
 */

/*	Prompt		*/

#define MONITOR_PROMPT		':'

/*	Command		*/

#define MONCMD_ENTER_WORD	(('e' << 8) | 'w')
#define MONCMD_DUMP_WORD	(('d' << 8) | 'w')
#define MONCMD_DUMP_BYTE	(('d' << 8) | 'b')
#define MONCMD_FILL_BYTE	(('f' << 8) | 'b')
#define MONCMD_LOAD		(('l' << 8) | 'd')
#define MONCMD_GO		(('g' << 8) | 'o')

/*	Error Code	*/

#define ERR_CHECK_SUM		0xf1

/*	Default Values	*/

#define DEF_DUMP_LENGTH		256
#define DEF_MON_SERIAL		1

/*
 *	External Data
 */                             

		.global		_MonitorVector

/*
 *	External Functions
 */

		.global		_EnterWordCmd
		.global		_DumpWordCmd
		.global		_DumpByteCmd
		.global		_FillByteCmd
		.global		_ParseCmdCore
		.global		_MonSendPrompt

#endif	/* of #ifndef _MONDEFS_H_ */
